3 # Author: Alan J. Pippin (apippin@pippins.net)
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
28 ##############################################################################################
30 ##############################################################################################
41 typeset profile="xvidvhq"
45 typeset default_alang="en"
46 typeset -i default_aid=128
47 typeset -i aid_override=-1
48 typeset -i force_onepass_mode=0
49 typeset -i eject_disk=1
50 typeset -i keep_isofile=0
51 typeset -i keep_vobfile=0
52 typeset -i keep_dvdfolder=0
53 typeset -i keep_intermediate_files=0
54 typeset -i make_final_dest_vob=0
55 typeset -i make_final_dest_iso=0
56 typeset -i make_final_dest_folder=0
57 typeset -i make_final_dest_comp=0
59 typeset -i show_usage=0
60 typeset -i mirror_mode=0
61 typeset -i target_bitrate=2000
62 typeset -i target_size=0
63 typeset -i audio_2ch=0
64 typeset -i audio_6ch=1
65 typeset -i invalid_feature_title=0
66 typeset -i feature_title_override=0
67 typeset -i mplayer_dumpstream_incompatibility=0
69 ##############################################################################
70 # Local Machine Settings:
71 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
72 # and the local conf file created by each local machine (rip_dvd.conf)
73 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
74 # This will allow you to override all the default values to meet your needs
75 # in a way that won't get clobbered when you pull updates from my GIT repo.
76 ##############################################################################
77 config="${0%/*}/rip_dvd.conf"
79 # The config file will be searched for in the following location order:
82 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
83 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
85 # 2) /path/to/rip_dvd/script/rip_dvd.conf
86 [ -e "${config}" ] && found_config=1 && . "${config}"
88 # 3) /etc/rip_dvd.conf
89 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
91 # 4) $PWD/rip_dvd.conf
92 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
94 # Check to make sure we found the config file
95 if [ $found_config -eq 0 ]; then
96 echo "-E- Unable to find the rip_dvd.conf file: $config"
100 ##############################################################################################
101 # Command line processing
102 ##############################################################################################
103 while (($#)) && getopts 162mvifkzx:ht:n:d:b:s:t:a:p:e:j:l: opt "$@"
106 (n) dvdname=$OPTARG;;
108 (b) target_bitrate=$OPTARG;;
109 (s) target_size=$OPTARG;;
112 (1) force_onepass_mode=1;;
113 (v) make_final_dest_vob=1;;
114 (i) make_final_dest_iso=1;;
115 (f) make_final_dest_folder=1;;
116 (z) make_final_dest_comp=1;;
117 (e) encoder=$OPTARG;;
119 (k) keep_intermediate_files=1;;
120 (t) feature_title_override=$OPTARG;;
122 (p) profile=$OPTARG;;
123 (x) extension=$OPTARG;;
124 (j) eject_disk=$OPTARG;;
125 (l) aid_override=$OPTARG;;
128 (:) echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
129 (\?) echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
136 echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
137 echo >&2 "Revision $REV"
139 echo >&2 " -d <destdir> Specify the destination directory to store the ripped DVD to"
140 echo >&2 " -n <dvdname> Specify a path to a DVD folder or file to process:"
141 echo >&2 " 1) If this option is not specified, the DVD will be ripped from $dev"
142 echo >&2 " 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
143 echo >&2 " 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
144 echo >&2 " 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
145 echo >&2 " -p <profile> Specify which encoding profile to use in -x mode as shown below:"
146 echo >&2 " Mencoder and Handbrake Encoder Profiles:"
147 echo >&2 " - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
148 echo >&2 " - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
149 echo >&2 " - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
150 echo >&2 " - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
151 echo >&2 " - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
152 echo >&2 " Handbrake Only Encoder Profiles:"
153 echo >&2 " - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
154 echo >&2 " - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
155 echo >&2 " - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
156 echo >&2 " - hb_<profile> = Any predefined HandBrake profile"
157 echo >&2 " -x <ext> Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
158 echo >&2 " If you run multiple instances of this script ripping the same DVD, you need to specify this option."
159 echo >&2 " -m Make a mirror image of the DVD and save it as a DVD ISO file"
160 echo >&2 " The default operation is non-mirror mode where only the main"
161 echo >&2 " feature title will be ripped."
162 echo >&2 " -v Make the final image a DVD VOB file"
163 echo >&2 " -i Make the final image a DVD ISO file"
164 echo >&2 " -f Make the final image a DVD folder"
165 echo >&2 " -z Make the final image a compressed file based on your profile selection and encoder"
166 echo >&2 " -e <encoder> Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
167 echo >&2 " You must also specify the target size or bitrate using the '-s' or '-b' options"
168 echo >&2 " -s <size> Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
169 echo >&2 " -b <bitrate> Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"
170 echo >&2 " -a <W:H> Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
171 echo >&2 " <W> If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
172 echo >&2 " The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
173 echo >&2 " -j <n> Eject the disk:"
174 echo >&2 " - 0 = do not eject the disk"
175 echo >&2 " - 1 = eject after the entire script is done (default)"
176 echo >&2 " - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
177 echo >&2 " The last option will allow you to start ripping another disk while the encoding process is running on a previous"
178 echo >&2 " -1 Force 1-pass encoding mode across all profiles"
179 echo >&2 " -2 Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
180 echo >&2 " -6 Use 6 channel AC3 audio encoding when making a compressed file (default)"
181 echo >&2 " -k Keep the intermediate files (good for debugging)"
182 echo >&2 " In -x mode, run with this option to keep the original .VOB file"
183 echo >&2 " By default, all intermediary files are deleted. Only the final image is kept"
184 echo >&2 " -l <aid> Specify the audio AID language ID to rip from the source DVD"
185 echo >&2 " -t <title> Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
186 echo >&2 " -w Set the sh Execute/Verbose flag (causes every command to be echoed)"
191 if (($errors)) || (($show_usage))
196 # Sanity Check - Command Line Options
197 if [ "$dest" == "" ]; then
198 echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
202 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
203 echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
207 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
208 echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
212 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] &&
213 [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
214 echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-z'" | tee -a $logfile
218 if [ $mirror_mode -eq 1 ]; then
219 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] ||
220 [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
221 echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
226 # Make handbrake the default encoder if not specified and we can find it
227 if [ -z "$encoder" ]; then
228 encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
229 [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
230 [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
231 [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
234 # Sanity check the profile selection
235 if [[ "$encoder" == "mencoder" ]]; then
236 [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
239 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
240 echo "-E- Invalid encoder specified: $encoder"
244 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
245 if [ "$aspect" != "" ]; then
246 echo "$aspect" | grep -q "x"
248 echo "-E- You must specify the aspect option with a value whose format is W:H"
251 echo "$aspect" | grep -q ":"
253 SCALE=",scale -zoom -sws 9 -xy $aspect"
255 SCALE=",scale=$aspect"
259 # Sanity Check - Key executables
260 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
261 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
262 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
263 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
264 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
265 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
266 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
267 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
268 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
269 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
270 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
272 ##############################################################################################
275 if [ -z "$dvdname" ]; then
277 # make sure the DVD device is accessible
278 volname $dev > /dev/null 2>&1
280 echo "-E- Can't access the DVD device $dev"
283 # now capture the volume name from the device
284 dvdname=`volname $dev | awk '{ print $1 }'`
289 # check to see if dvdname is a full path to a real directory
290 # if it is, set dvdname and dvdpath appropriately
291 if [ -d "$dvdname" ]; then
293 dvdname=`basename "$dvdname"`
295 if [ -z "$dvdname" ]; then
296 echo "-E- Unable to extract dvdname from path: $dvdpath"
299 if [ ! -d "$dvdpath/VIDEO_TS" ]; then
300 echo "-E- You must supply a full path to a valid DVD folder with this option"
305 # Check to see if dvdname is a full path to a file
306 if [ -f "$dvdname" ]; then
309 # check to see if dvdname is a full path to an MPG2 (VOB) file
310 # if it is, set dvdname and vobfile appropriately
311 file "$dvdname" | grep -q "MPEG"
313 # It is a valid MPEG2 file, now strip the extension off our dvdname
315 dvdname=`basename "$dvdname"`
316 dvdname=${dvdname%.[^.]*}
321 # check to see if dvdname is a full path to an ISO file
322 # if it is, set dvdname and isofile appropriately
323 file "$dvdname" | grep -q -e "ISO" -e "UDF"
325 # It is a valid ISO file, now strip the extension off our dvdname
327 dvdname=`basename "$dvdname"`
328 dvdname=${dvdname%.[^.]*}
333 # check to see if dvdname is a full path to an ISO file
334 # if it is, set dvdname and isofile appropriately
335 file "$dvdname" | grep -q -e "VOB"
337 # It is a valid VOB file, now strip the extension off our dvdname
339 dvdname=`basename "$dvdname"`
340 dvdname=${dvdname%.[^.]*}
345 # If we didn't find a handler for the file above, complain
346 if [ $valid_file -eq 0 ]; then
347 echo "-E- Unsupported file type: $vobfile"
351 # Throw an error if we can't find what the -n option is pointing to
353 echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
357 # Set the ripdvd flag to false since we aren't ripping a DVD disk
360 # Since we aren't ripping a DVD disk, don't eject anything either
365 # remove bad characters from the dvdname
366 dvdname=${dvdname%.} # remove trailing '.' character
368 # add the suffix extension to the end of the dvdname
369 dvdname=$dvdname$extension
371 # make a "safe" dvdname (remove special characters)
372 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
374 # Make sure we have a non-empty dvdname
375 if [ -z "$dvdname" ]; then
376 echo "-E- unable to determine dvdname"
380 # make sure our vobfile value is set
381 if [ -z "$vobfile" ]; then
382 vobfile="$dest/$dvdname.VOB"
385 # set up some variables to hold various logfiles
386 logfile="$logdir/$dvdname.log"
387 passlogfile="$tmpdir/$safedvdname.log"
388 ddrescuelog=`tempfile`
389 dvdauthorlog=`tempfile`
393 # create the tmpdir if it doesn't already exist
394 if [ ! -d "$tmpdir" ]; then
397 echo "-E- Unable to create the tmpdir: $tmpdir"
402 # create the logdir if it doesn't already exist
403 if [ ! -d "$logdir" ]; then
406 echo "-E- Unable to create the logdir: $logdir"
411 ##############################################################################################
413 ##############################################################################################
415 if [ $keep_intermediate_files -eq 0 ]; then
416 [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
417 [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
418 [[ -e "$encodelog" ]] && rm -f "$encodelog"
419 [[ -e "$dumplog" ]] && rm -f "$dumplog"
421 [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
422 [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
423 [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
424 [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
430 if [[ -z "$1" ]]; then
431 msg="-E- control-c killed us"
435 echo -e 2>&1 "$msg" | tee -a "$logfile"
436 if [[ -n "$mailto" ]]; then
437 echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
439 keep_intermediate_files=1
443 # Call our cleanup functions on INT and EXIT signals
444 trap fatal_and_exit INT
447 ##############################################################################################
448 # processing functions
449 ##############################################################################################
451 # encode the vob file into a compressed file format using handbrake
452 function encode_vob_file_handbrake {
454 # declare some globals
455 typeset handbrake_cli=""
456 typeset handbrake_video_encoder_opts=""
458 typeset handbrake_audio_opts=""
460 # Set a variable that we will use later to determine if we found a handler for $profile or not
461 typeset -i found_profile=0
463 # For a given profile, to override the 2 pass behavior to be single pass,
464 # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler.
465 # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
468 # Check the global force_onepass_mode. If it is set, change our variables appropriately
469 # to force 1-pass encoding across all profiles.
470 if [ $force_onepass_mode -eq 1 ]; then
475 if [[ "$profile" =~ "xvid" ]]; then
477 handbrake_cli="$handbrake_xvid"
478 final_output_file="$dest/$dvdname.avi"
481 # Very High Quality (16fps)
482 if [ "$profile" == "xvidvhq" ]; then
483 handbrake_opts[0]="-f avi"
484 handbrake_opts[1]="-b $target_bitrate"
485 handbrake_opts[2]="-e ffmpeg"
486 handbrake_opts[3]="-T"
487 handbrake_opts[4]="-5"
488 handbrake_opts[5]="-8"
490 # High Quality (20fps)
491 if [ "$profile" == "xvidhq" ]; then
492 handbrake_opts[0]="-f avi"
493 handbrake_opts[1]="-b $target_bitrate"
494 handbrake_opts[2]="-e ffmpeg"
495 handbrake_opts[3]="-T"
496 handbrake_opts[4]="-5"
499 if [ "$profile" == "xvid" ]; then
500 handbrake_opts[0]="-f avi"
501 handbrake_opts[1]="-b $target_bitrate"
502 handbrake_opts[2]="-e ffmpeg"
503 handbrake_opts[3]="-T"
508 if [[ "$profile" =~ "mp4" ]]; then
510 handbrake_cli="$handbrake_mp4"
511 final_output_file="$dest/$dvdname.mp4"
515 if [ "$profile" == "mp4vhq" ]; then
516 profile="hb_High_Profile"
519 if [ "$profile" == "mp4hq" ]; then
523 if [ "$profile" == "mp4" ]; then
528 # iphone and ipod MP4 profiles
529 if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
531 handbrake_cli="$handbrake_mp4"
532 final_output_file="$dest/$dvdname.mp4"
536 if [ "$profile" == "iphone" ]; then
540 if [ "$profile" == "ipod" ]; then
545 # Predefined Handbrake Profile Handling
546 if [[ "$profile" =~ "hb" ]]; then
548 handbrake_cli="$handbrake_mp4"
549 final_output_file="$dest/$dvdname.mp4"
552 # extract the HandBrake Profile name from $profile
553 hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
554 handbrake_opts[0]="-Z \"$hb_profile\""
557 # Make sure we found a handler for the given profile
558 if [ $found_profile -eq 0 ]; then
559 fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
562 # setup our audio option
563 if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
564 handbrake_audio_opts="-E faac,ac3 -6 dpl2,6ch"
566 if [ $audio_6ch -eq 1 ]; then
567 handbrake_audio_opts="-E ac3 -6 6ch"
569 if [ $audio_2ch -eq 1 ]; then
570 handbrake_audio_opts="-E faac -6 dpl2"
573 # Convert our array of opts into a string
574 for OPTS in "${video_encoder_opts[@]}"; do
575 handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
577 if [ -n "$handbrake_video_encoder_opts" ]; then
578 handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
580 for OPTS in "${handbrake_opts[@]}"; do
581 handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
584 # Execute the handbrake command to encode the video
585 echo -e "\n Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1" >> "$logfile"
586 $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1
588 if [ $handbrake_retval != 0 ]; then
589 fatal_and_exit "-E- Unhandled handbrake error"
592 # Concatenate the encode log to our main log file, greping out unwanted lines
593 cat $encodelog | grep -v "Encoding" >> "$logfile"
594 cat $encodelog | grep "Encoding:" | sed 's/
\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
595 cat $encodelog | grep "Encoding:" | sed 's/
\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
598 # encode the vob file into a compressed file format using mencoder
599 function encode_vob_file_mencoder {
601 # Set a variable that we will use later to determine if we found a handler for $profile or not
602 typeset -i found_profile=0
604 # For a given profile, to override the 2 pass behavior to be single pass,
605 # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler.
606 # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
609 # Declare our default 2 pass variables
610 passlogfile_opt="-passlogfile $passlogfile"
611 pass_opt="pass=%PASS"
613 # Check the global force_onepass_mode. If it is set, change our variables appropriately
614 # to force 1-pass encoding across all profiles.
615 if [ $force_onepass_mode -eq 1 ]; then
622 if [[ "$profile" =~ "xvid" ]]; then
624 final_output_file="$dest/$dvdname.avi"
625 mencoder_general_opts="$lang_opts $passlogfile_opt"
626 mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
627 mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
628 mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
630 # Very High Quality (16fps)
631 if [ "$profile" == "xvidvhq" ]; then
632 video_encoder_opts[0]="bitrate=$target_bitrate"
633 video_encoder_opts[1]="threads=$mencoder_threads"
634 video_encoder_opts[2]="chroma_opt"
635 video_encoder_opts[3]="vhq=4"
636 video_encoder_opts[4]="bvhq=1"
637 video_encoder_opts[5]="quant_type=mpeg"
638 video_encoder_opts[6]="autoaspect"
640 # High Quality (20fps)
641 if [ "$profile" == "xvidhq" ]; then
642 video_encoder_opts[0]="bitrate=$target_bitrate"
643 video_encoder_opts[1]="threads=$mencoder_threads"
644 video_encoder_opts[2]="chroma_opt"
645 video_encoder_opts[3]="vhq=2"
646 video_encoder_opts[4]="bvhq=1"
647 video_encoder_opts[5]="quant_type=mpeg"
648 video_encoder_opts[6]="autoaspect"
651 if [ "$profile" == "xvid" ]; then
652 video_encoder_opts[0]="bitrate=$target_bitrate"
653 video_encoder_opts[1]="threads=$mencoder_threads"
654 video_encoder_opts[2]="vhq=0"
655 video_encoder_opts[3]="turbo"
656 video_encoder_opts[4]="autoaspect"
659 for OPTS in "${video_encoder_opts[@]}"; do
660 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
663 if [ $audio_2ch -eq 0 ]; then
664 # These options produce good 6 channel audio for linux and windows
665 mencoder_audio_opts="-oac copy"
666 # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
667 mencoder_audioch_opts[0]="-channels 6 -af channels=6"
668 mencoder_audioch_opts[1]="-af channels=6"
669 mencoder_audioch_opts[2]=""
671 # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
672 mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
673 mencoder_audioch_opts[0]=""
678 # iphone and ipod MP4 profiles
679 if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
681 if [ "$profile" == "iphone" ]; then
683 # scale width to 480, set height appropriately, but keep a multiple of 16
684 #SCALE=",scale=480:-10"
685 # scale the video down however far is necessary to fit in 480x320
686 SCALE=",dsize=480:320:0,scale=-8:-8"
689 # scale width to 320, set height appropriately, but keep a multiple of 16
690 #SCALE=",scale=320:-10"
691 # scale the video down however far is necessary to fit in 320x240
692 SCALE=",dsize=320:240:0,scale=-8:-8"
694 final_output_file="$dest/$dvdname.mp4"
695 mencoder_general_opts="$lang_opts $passlogfile_opt"
696 mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
697 mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
698 mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
699 video_encoder_opts[0]="bitrate=$target_bitrate"
700 video_encoder_opts[1]="threads=$mencoder_threads"
701 video_encoder_opts[2]="vbv_maxrate=1500"
702 video_encoder_opts[3]="vbv_bufsize=2000"
703 video_encoder_opts[4]="nocabac"
704 video_encoder_opts[5]="me=umh"
705 video_encoder_opts[6]="subq=6"
706 video_encoder_opts[7]="frameref=6"
707 video_encoder_opts[8]="trellis=1"
708 video_encoder_opts[9]="level_idc=30"
709 video_encoder_opts[10]="global_header"
710 video_encoder_opts[11]="bframes=0"
711 video_encoder_opts[12]="partitions=all"
712 for OPTS in "${video_encoder_opts[@]}"; do
713 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
716 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
717 mencoder_audioch_opts[0]="-channels 2 -srate 48000"
720 if [ $found_profile -eq 0 ]; then
721 fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
724 # Do not edit this line. $mencoder_video_encoder_opts must be last
725 mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
730 # Set some options based on which pass we are in
731 mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
732 [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
733 [ $PASS -eq 1 ] && output_file="/dev/null"
734 [ $PASS -eq 2 ] && output_file="$final_output_file"
736 # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
737 for CH_OPTS in "${mencoder_audioch_opts[@]}";
739 echo -e " Encoding pass $PASS"
740 echo -e "\n Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
741 mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
743 grep -q "\[channels\] Invalid" $encodelog
747 echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
751 if [ $mencoder_retval != 0 ]; then
752 fatal_and_exit "-E- Unhandled mencoder error"
755 # Concatenate the encode log to our main log file, greping out unwanted lines
756 cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
761 function make_dvd_iso_image {
765 # check to see if we have a dvdpath to rip from instead of $dev
766 if [ -z "$dvdpath" ]; then
767 # load the CSS codes in the DVD drive
768 lsdvd $dev >> "$logfile"
770 fatal_and_exit "-E- lsdvd $dev failed"
773 # read the DVD, ignoring/skipping CRC errors
774 ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
776 fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
778 cat "$ddrescuelog" >> "$logfile"
780 # rip from a path instead
781 make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
785 function make_dvd_iso_image_from_folder {
791 echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
793 # make an iso image out of our directory
794 echo " mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
795 mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
797 # set the audio languages from the iso if it exists and is non-zero in size
798 if [ -s "$dst" ]; then
799 get_feature_title "$dst"
800 get_audio_id_from_iso "$dst"
803 # make sure we were able to create the iso image from the folder given to us
804 if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
805 echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
806 echo " Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
807 # remove the bad iso file
808 [[ -e "$dst" ]] && rm -f "$dst"
809 # get the feature title from the DVD folder
810 get_feature_title "$dvdpath"
811 # create our main VOB file from the ISO
812 create_main_vob_with_mplayer "$dvdpath"
813 # get our audio id from the VOB file
814 get_audio_id_from_vob "$vobfile"
818 function make_dvdbackup_folder_image {
819 # extract the feature title from the DVD image
820 echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
821 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
822 dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
824 fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
828 function make_dvdauthor_folder_image {
829 # create a new DVD video of the feature title
830 echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
831 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
832 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
833 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
835 # There is a chance that dvdauthor won't like some of the VOBs.
836 # We can't tell ahead of time which ones it will choke on.
837 # So, we need to run it over and over again until it can process
838 # all the VOBs. If it can't handle one of them, run it through
839 # mencoder to fix it and try again. These errors are typically
840 # present due to the copy protection that ddrescue removed.
841 grep -q "SCR moves" $dvdauthorlog
842 while [ $? == 0 ]; do
843 # fix bad vobs that get the "SCR moves backwards" error:
844 # STAT: Processing VTS_01_0.VOB...
845 # ERR: SCR moves backwards, remultiplex input.
846 badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
847 if [[ ! -f "$badvob" ]]; then
848 fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
850 echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
851 cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
852 mv -f $badvob.fixed $badvob
853 echo "-> Creating DVD video $dest/$dvdname"
854 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
855 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
856 grep -q "SCR moves" $dvdauthorlog
860 function get_feature_title {
862 # if a feature title was given on the command line, use it
863 if [ $feature_title_override -ne 0 ]; then
864 feature_title=$feature_title_override
867 # otherwise, use lsdvd to figure it out
868 if [ $ripdvd -eq 1 ]; then
869 feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
871 feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
875 function create_main_vob_with_cat {
876 # cd to the feature title DVD folder
877 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
879 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
882 # concatenate all the VOBs together into 1 giant VOB
883 vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
884 cat $vobs > "$tmpdir/$dvdname.VOB"
886 # cd back to the dir we started from
887 popd > /dev/null 2>&1
890 function create_main_vob_with_mplayer {
892 # argument processing
896 # make sure we have a valid feature title
897 if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
898 fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
901 # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
902 if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
903 msg="-E- We detected an mplayer dumpstream incompatibility earlier."
904 msg="$msg We also detected another condition that requires us to use dumpstream. "
905 msg="$msg\n Unable to rip this DVD in the mode you requested."
906 fatal_and_exit "$msg"
909 # use mplayer to create the main VOB file
910 echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
911 echo " mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
912 mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
914 cat $dumplog | grep -v "^A:" >> "$logfile"
915 fatal_and_exit "-E- Mplayer Failed"
917 cat $dumplog | grep -v "^A:" >> "$logfile"
918 [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
921 function get_audio_id_from_iso {
922 # Adjust our audio ID to find the english audio stream
923 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
928 if [ $aid_override -lt 0 ]; then
929 mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
930 grep -q "aid: $aid" $aidcheck
931 while [ $? == 1 ] && [ $aid -lt 159 ]; do
933 grep -q "aid: $aid" $aidcheck
935 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
939 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
940 # mencoder default DVD audio track language selection (english)
941 lang_opts="-aid $aid -alang $alang"
944 function get_crop_from_iso {
946 echo "-> Detecting black frame border crop value from ISO file"
947 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
948 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
949 [[ -e "md5sums" ]] && rm -f "md5sums"
950 CROP=`cat $dumplog | grep CROP | tail -1`
951 echo " Found crop value of $CROP" >> "$logfile"
955 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
956 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
957 if [ -z "$CROP" ]; then
958 echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
961 if [ $CROPCHECK -lt 0 ]; then
966 echo " Setting mencoder crop filter to: $CROP"
969 function get_crop_from_vob {
971 echo "-> Detecting black frame border crop value from VOB file"
972 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
973 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
974 [[ -e "md5sums" ]] && rm -f "md5sums"
975 CROP=`cat $dumplog | grep CROP | tail -1`
976 echo " Found crop value of $CROP" >> "$logfile"
980 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
981 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
982 if [ -z "$CROP" ]; then
983 echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
986 if [ $CROPCHECK -lt 0 ]; then
991 echo " Setting mencoder crop filter to: $CROP"
994 function get_audio_id_from_vob {
995 # Adjust our audio ID to find the english audio stream
996 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1000 alang=$default_alang
1001 if [ $aid_override -lt 0 ]; then
1002 mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1003 grep -q "Found audio stream: $aid" $aidcheck
1004 while [ $? == 1 ] && [ $aid -lt 159 ]; do
1006 grep -q "Found audio stream: $aid" $aidcheck
1008 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1012 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1013 # mencoder default DVD audio track language selection (english)
1014 lang_opts="-aid $aid -alang $alang"
1017 function check_vob_for_corrupted_start {
1018 # check to see if the beginning of the DVD has a form of copy protection
1019 # where they have deliberately broken the first X number of frames of the DVD.
1020 # If we don't skip these, our resulting VOB file will not play.
1021 badvobcheck=`tempfile`
1024 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1025 if [ $? != 0 ]; then
1026 fatal_and_exit "-E- Mencoder Failed"
1028 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1029 while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1030 (( skip = skip + 5 ))
1031 echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1032 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1033 if [ $? != 0 ]; then
1034 fatal_and_exit "-E- Mencoder Failed"
1036 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1038 [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1040 # cat the giant VOB into mencoder to create a playable VOB file
1041 cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1042 if [ $? != 0 ]; then
1043 fatal_and_exit "-E- Mencoder Failed"
1047 function check_vob_for_completeness {
1048 # check to make sure we got out a complete VOB.
1049 # there is another kind of copy protection where the VOB's may
1050 # have "MPG EOF" frames in the middle of the stream.
1051 # this causes mencoder to not process the entire VOB, and exit without any errors.
1052 # detect this by seeing how much smaller the dst vob is from the src vob.
1053 MAX_FILESIZE_DELTA_PERCENT=70
1054 SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1055 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1056 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1057 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1058 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1059 echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1060 create_main_vob_with_mplayer "$isofile"
1061 [[ -e "$dumplog" ]] && rm -f $dumplog
1062 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1063 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1064 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1065 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
1070 function check_vob_for_too_many_video_packets {
1071 # If our earlier algorithm to work around this failed, throw an error.
1072 # check to see if this DVD has a protection scheme we don't know how to work around
1073 # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1074 # for some reason, the video is black, while the audio rolls, then the video finally comes
1075 # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of
1076 # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1077 # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1078 grep -q "Too many video packets in the buffer:" "$logfile"
1079 if [ $? == 0 ]; then
1080 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1081 echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1082 create_main_vob_with_mplayer "$isofile"
1083 grep -q "Too many video packets in the buffer:" $dumplog
1084 if [ $? == 0 ]; then
1085 [[ -e "$dumplog" ]] && rm -f $dumplog
1086 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
1088 [[ -e "$dumplog" ]] && rm -f $dumplog
1092 function check_vob_for_a52_crc_errors {
1093 # Let's see if we can playback our newly created VOB file without any errors.
1094 # if there are issues, let's detect them now, and try to recreate the VOB
1095 # there are some forms of copy protection that have missed above, that evidence
1096 # themselves when we try to playback the VOB file. This was added to deal with
1097 # the "a52: CRC check failed" copy protection scheme.
1100 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1101 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1102 cat $dumplog | grep -v "^A:" >> "$logfile"
1103 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1104 if [ $errors -gt $MAX_ERRORS ]; then
1105 echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1106 create_main_vob_with_mplayer "$isofile"
1107 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1108 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1109 if [ $? != 0 ]; then
1110 cat $dumplog | grep -v "^A:" >> "$logfile"
1111 fatal_and_exit "-E- Mplayer Failed"
1113 cat $dumplog | grep -v "^A:" >> "$logfile"
1114 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1115 if [ $errors -gt $MAX_ERRORS ]; then
1116 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
1119 [[ -e "$dumplog" ]] && rm -f $dumplog
1122 function calculate_bitrate_from_target_size {
1123 # determine what our bitrate needs to be if a target size was specified instead
1124 if [ $target_size -ne 0 ]; then
1125 vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1126 ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1127 echo " With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1131 function create_dvdauthor_dvd_xml_file {
1132 # make a dvdauthor xml menu file to create a valid DVD video from
1133 # this script does a good job, but we'll still need to clean it up a bit after it runs
1134 echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1135 makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1136 if [ $? != 0 ]; then
1137 fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1140 # replace the first line of the xml file to remove the bad dest path
1141 awk -v line=1 -v new_content="<dvdauthor>" '{
1147 }' dvd.xml > dvd.xml.new
1148 mv -f dvd.xml.new dvd.xml
1149 if [ $? != 0 ]; then
1150 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1153 # remove the "<video " property line from the xml file
1154 cat dvd.xml | grep -v "<video" > dvd.xml.new
1155 mv -f dvd.xml.new dvd.xml
1156 if [ $? != 0 ]; then
1157 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1160 # remove the extra <pgc>..</pgc> pairs
1161 cat dvd.xml | awk 'BEGIN {x=1}
1163 if ($0~"</pgc>") {x=0}
1164 if (x==1) {print $0}
1165 if ($0~"<pgc>") {x=1}
1167 echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1168 mv -f dvd.xml.new dvd.xml
1169 if [ $? != 0 ]; then
1170 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1173 # remove the VTS_*_0.VOB file as this is just the main menu video clip
1174 cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1175 mv -f dvd.xml.new dvd.xml
1176 if [ $? != 0 ]; then
1177 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1181 function check_for_mplayer_dumpstream_incompatibility {
1183 echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1185 if [ ! -e "$vobfile" ]; then
1186 # mplayer dumpstream does not work on DVDs that obscure the feature title.
1187 # A DVD that has 99 titles, where the longest title isn't the main feature
1188 # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1189 # out what the feature title is. This script will run through that flow if we
1190 # set use_mplayer_dumpstream to 0. Check for this here.
1191 if [ $ripdvd -eq 1 ]; then
1192 lsdvd $dev | grep -q "Title: 99"
1194 lsdvd "$isofile" | grep -q "Title: 99"
1196 # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1197 if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1198 if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1199 echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1200 echo " You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1201 echo " You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1202 invalid_feature_title=1
1204 echo " Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1205 echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1206 echo " You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1207 use_mplayer_dumpstream=0
1208 invalid_feature_title=1
1214 # There is another form of protection that causes the mplayer dumpstream to fail.
1215 # This can be detected by telling mplayer to parse the VOB file by copying its audio
1216 # video streams to a dummy output file (/dev/null). Do that here to check for that
1217 # problem before continuing.
1218 if [ -e "$vobfile" ]; then
1219 mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1220 mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1221 grep -q "Too many audio packets in the buffer" $dumplog
1222 if [ $? == 0 ]; then
1223 echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1224 use_mplayer_dumpstream=0
1225 mplayer_dumpstream_incompatibility=1
1227 [[ -e "$dumplog" ]] && rm -f $dumplog
1231 function fill_mythvideo_metadata {
1233 # This function must be passed the filename as an argument
1234 # The filename must be a full path to the file
1237 # Make sure the fill mythvideo metadata option has been set to 1
1238 if [ $fill_mythvideo_metadata -eq 0 ]; then
1239 echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1243 # If the fill mythvideo metadata script is present, run it
1244 # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1245 if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1246 echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1247 fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1249 echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1250 echo " Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1254 # remove the intermediate VOB file
1255 function remove_intermediate_vob_file {
1256 if [ $keep_intermediate_files -eq 0 ]; then
1257 [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1259 echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1263 # remove the original DVD image
1264 function remove_intermediate_iso_file {
1265 [[ $keep_isofile -eq 1 ]] && return 1
1266 if [ $keep_intermediate_files -eq 0 ]; then
1267 [[ -e "$isofile" ]] && rm "$isofile"
1269 echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1273 # remove the intermediate dvdbackup folder
1274 function remove_intermediate_dvdbackup_folder {
1275 if [ $keep_intermediate_files -eq 0 ]; then
1276 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1278 echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1282 ##############################################################################################
1284 ##############################################################################################
1286 # Make a note of when this DVD rip started
1288 echo -e "\n$date DVD rip started" >> "$logfile"
1289 echo "$cmd" >> "$logfile"
1291 # Rip the DVD - Mirror Mode
1292 if [ $mirror_mode -eq 1 ]; then
1293 echo "-> Ripping DVD $dvdname to $dest"
1295 # use ddrescue to make an ISO image of the disk
1296 make_dvd_iso_image "$dest/$dvdname.iso"
1298 # add this video data to the mythtv DB
1299 fill_mythvideo_metadata "$dest/$dvdname.iso"
1301 # eject the disk upon completion
1302 if [ $eject_disk -ne 0 ]; then
1307 echo "$date DVD rip completed" | tee -a "$logfile"
1309 if [[ -n "$mailto" ]]; then
1310 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1315 # Rip the DVD - Main Title Feature Only
1316 if [ $mirror_mode -eq 0 ]; then
1318 # Rip image from DVD
1319 if [ $ripdvd -eq 1 ]; then
1320 echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1321 # use ddrescue to make an ISO image of the disk
1322 make_dvd_iso_image "$tmpdir/$dvdname.iso"
1325 # Rip image from DVD path
1326 if [ -n "$dvdpath" ]; then
1327 echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1328 make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1331 # make sure our isofile value is set
1332 if [ -z "$isofile" ]; then
1333 isofile="$tmpdir/$dvdname.iso"
1336 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1338 if [ ! -e "$vobfile" ]; then
1339 echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1341 # get the feature title from the ISO
1342 get_feature_title "$isofile"
1344 # get the crop value from the ISO
1347 # check for mplayer dumpstream incompatibilities
1348 # if they exist, this method will set this mode to 0.
1349 check_for_mplayer_dumpstream_incompatibility
1351 if [ $use_mplayer_dumpstream -eq 1 ]; then
1353 # get our audio id from the ISO file
1354 get_audio_id_from_iso "$isofile"
1356 # create our main VOB file from the ISO
1357 create_main_vob_with_mplayer "$isofile"
1359 # remove the intermediate VOB file
1360 remove_intermediate_vob_file
1362 # it's possible that our VOB is still corrupted in some manner
1363 # check to make sure it is still a good VOB before continuing.
1364 check_for_mplayer_dumpstream_incompatibility
1368 if [ $use_mplayer_dumpstream -eq 0 ]; then
1370 # use dvdbackup to make a DVD folder of the feature title
1371 make_dvdbackup_folder_image
1373 # create our main VOB file
1374 create_main_vob_with_cat
1376 # get our audio id from the VOB file
1377 get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1379 # check for corrupted VOB start
1380 check_vob_for_corrupted_start
1382 # check to make sure our VOB is complete
1383 check_vob_for_completeness
1385 # check to make sure our VOB doesn't have too many video packets
1386 check_vob_for_too_many_video_packets
1388 # check to make sure our VOB doesn't have a52 crc errors
1389 check_vob_for_a52_crc_errors
1391 # remove the intermediate VOB file
1392 remove_intermediate_vob_file
1396 # remove the intermediate ISO file
1397 remove_intermediate_iso_file
1400 if [ "$encoder" != "handbrake" ]; then
1401 echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1402 # get our audio id from the VOB file
1403 get_audio_id_from_vob "$vobfile"
1404 # get the crop value from the VOB
1409 # eject the DVD disk since we are finished with it
1410 [ $eject_disk -eq 2 ] && eject -T $dev
1412 # encode the VOB file to a compressed file format
1413 if [ $make_final_dest_comp -eq 1 ]; then
1414 echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1416 # determine what our bitrate needs to be if a target size was specified instead
1417 calculate_bitrate_from_target_size
1419 # encode the vob file into a compressed file format
1420 if [[ "$encoder" == "mencoder" ]]; then
1421 encode_vob_file_mencoder
1423 if [[ "$encoder" == "handbrake" ]]; then
1424 encode_vob_file_handbrake
1427 if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1428 [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1429 [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1431 echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1432 echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1436 # add this video data to the mythtv DB
1437 [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file"
1438 [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile"
1442 # use dvdbackup to make a DVD folder of the feature title
1443 make_dvdbackup_folder_image
1445 # cd to the feature title DVD folder
1446 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1447 if [ $? != 0 ]; then
1448 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1451 # create the dvd.xml file for dvdauthor
1452 create_dvdauthor_dvd_xml_file
1454 # make the final DVD folder image
1455 make_dvdauthor_folder_image
1457 # add this video data to the mythtv DB
1458 fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS"
1460 # cd back to the dir we started from
1461 popd > /dev/null 2>&1
1463 if [ $make_final_dest_iso -eq 1 ]; then
1465 # make an iso image out of our directory
1466 make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1468 # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory
1469 if [ -s "$dest/$dvdname.iso" ]; then
1470 if [ $make_final_dest_folder -eq 0 ]; then
1471 echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1472 # remove the folder of the DVD image now that we have a .iso version of it
1473 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1476 # we created an empty iso file, remove it
1477 echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1478 echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1479 [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1482 # add this video data to the mythtv DB
1483 fill_mythvideo_metadata "$dest/$dvdname.iso"
1489 # remove the ddrescue DVD ISO image
1490 remove_intermediate_iso_file
1492 # remove the tmp dvdbackup folder of the DVD image
1493 remove_intermediate_dvdbackup_folder
1495 # eject the DVD disk upon completion
1496 [ $eject_disk -eq 1 ] && eject -T $dev
1499 echo "$date DVD rip completed" | tee -a "$logfile"
1501 if [[ -n "$mailto" ]]; then
1502 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1507 ##############################################################################################